// $Id: dir.c,v 1.11 2001/03/12 16:30:42 tma Exp $
/******************************************************************************
 *   ...
 ******************************************************************************/

#include <stdio.h>
#include <sys/stat.h>
#include <unistd.h>
#include <dirent.h>
#include <limits.h>
#include <ctype.h>
#include "includes.h"

#ifdef	TEST
int scandirectory(char*,int);
int main()
{
	scandirectory( "/tmp", -1 );
	return( 0 );
}
#else

GLOBAL_TYPE *gl;

#endif	/* TEST */

int scandirectory(char *directory, int r)
{
	DIR *d = NULL;
	struct dirent *dp;
	struct stat statv;
#ifdef	DESC
	FILE *f = NULL;
	char desc[PATH_MAX];
#endif	/* DESC */
	char tmpdir[PATH_MAX];

	if( ( d = opendir( directory ) ) == NULL )
	{
		fprintf( stderr, "Directory \"%s\" cannot be opened - ",
				directory );
		perror( "opendir" );
		return( -1 );
	}

	while( ( dp = readdir( d ) ) )
	{
#ifdef	WIN32
		snprintf( freq.file, sizeof(freq.file)-1, "%s\\%s",
			directory, dp->d_name );
#else
		snprintf( freq.file, sizeof(freq.file)-1, "%s/%s",
			directory, dp->d_name );
#endif	/* WIN32 */
		if( stat( freq.file, &statv ) )
		{
			perror( "stat" );
			return( -1 );
		}

		switch( statv.st_mode&S_IFMT )
		{
			case S_IFDIR:
			if( !r ) break;
			if( strcmp( dp->d_name, "." ) &&
					strcmp( dp->d_name, ".." ) &&
					dp->d_name[0] != '.' )
			{
#ifdef	WIN32
				sprintf( tmpdir, "%s\\%s", directory,
						dp->d_name );
#else
				snprintf( tmpdir, sizeof(tmpdir)-1,
					"%s/%s", directory, dp->d_name );
#endif	/* WIN32 */
#ifndef	DONOT_STDOUT
				fprintf( stdout, "Dir: %s\n", tmpdir );
#endif	/* DONOT_STDOUT */
				if( scandirectory( tmpdir, r ) ) break;
			}
				break;
#ifndef	WIN32
			case S_IFLNK:
				break;
#endif	/* WIN32 */
			case S_IFREG:
			if( dp->d_name[0] != '.' )
			{
				strcpy( freq.path, directory );
				strcpy( freq.file, dp->d_name );
#ifndef	DONOT_STDOUT
#ifdef	WIN32
				fprintf( stdout, "File: %s\\%s ", directory,
						dp->d_name );
#else
				fprintf( stdout, "File: %s/%s ", directory,
						dp->d_name );
#endif	/* WIN32 */
#ifdef	DEBUG
				fprintf( stdout, "\n" );
#endif	/* DEBUG */
#endif	/* DONOT_STDOUT */

#ifdef	DESC

#ifndef	DEBUG
				//   freq.system - 'a'
				// (all systems).
				freq.system = 'a';

//#ifdef	DESC
				//       
				//  ...
#ifdef	WIN32
				sprintf( desc, "%s\\.desc\\.desc", directory );
#else
				snprintf( desc, sizeof(desc)-1,
						"%s/.desc/.desc", directory );
#endif	/* WIN32 */
#endif	/* DEBUG */
				if( ( f = fopen( desc, "r" ) ) == NULL )
				{
#ifndef	TEST
					freq.system = gl->defsys;
#endif	/* TEST */
				}
				else
				{
					//     .
					freq.system = tolower( fgetc( f ) );
					fclose( f );	//  .
				}

				//     'a'  'l',
				//    - 'p' (protected systems)
#ifdef	TEST
				freq.system = 'p';
#else
				if( freq.system != 'a' && freq.system != 'l'
					&& freq.system != 'p' )
					freq.system = gl->defsys;
#endif	/* TEST */
#endif	/* DESC */
#ifndef	DEBUG
				insert();
#endif	/* DEBUG */
			}
			else
			{
				fprintf( stdout, "File \"%s\" ignored!\n",
						dp->d_name );
			}
				break;
			default:
				break;
		}
	}

	closedir( d );

	return( 0 );
}

